#!/usr/bin/python3

# vtable helpers
# this should probably be cleaned up and moved somewhere else

import typing

from cle.backends.symbol import Symbol

if typing.TYPE_CHECKING:
    from .validate import LinuxBinary

VTable = list[Symbol]


def get_windows_vtables_from(bin: "LinuxBinary", vt: Symbol) -> VTable:
    return bin.vtable_disambiguator.get_windows_vtables_from(vt)


def get_constrained_vfn(
    bin: "LinuxBinary", vt: Symbol, vfnidx: int, candidate_fnsyms: set[Symbol]
) -> Symbol | None:
    return bin.vtable_disambiguator.get_constrained_vfn(vt, vfnidx, candidate_fnsyms)


def get_vtables_from_address(bin: "LinuxBinary", vt: Symbol) -> list[VTable]:
    return bin.vtable_disambiguator.get_vtables_from_address(vt)
